<bugID>713820<Summary>New Safari Migrator: Top Sites and Reading List issues</Summary><Description>Over the years since the old Safari Migrator landed, the bookmarks UE in Safari has changed quite a bit:
1. Safari 4 added Top Sites
2. Safari 5 added Reading List.

Legacy bookmarks support still exist in Safari, of course, and people sure still use the bookmarks toolbar in Safari, but as for other bookmarks, Safari encourages the user to use Top Sites and Reading List as places for bookmarks: Reading List is the default location for new bookmarks, followed by Top Sites in the combo box (If you're testing on windows and don't see Top Sites, make sure DirectX is enabled).

With all that in mind, we cannot ignore these bookmarks locations, even though they're not one hundred percent "bookmarks". However,  Firefox has neither of these concepts for bookmarking, so it's not so clear how to migrate them.

Top Sites
---------
These are just easy-access bookmarks. Apple made it easy to distinguish their built in Top Sites from Top Sites added by the user. So we can filter away the built in items.
I think they should go to the bookmarks menu, before the other bookmarks imported from the bookmarks menu in Safari, with a separator between the groups:
 [Bookmarks]
  [Top Site 1]
  [Top Site 2]
  [----------]
  [Bookmark imported from Safari's bookmarks menu 1]
  [Bookmark imported from Safari's bookmarks menu 2]

That is, of course, in the case of start-up-migration. For the case of migration through the Places Organizer ("Import from Another Browser"), these items will go under the From Safari folder (located under the bookmarks menu).

This is the solution I'll be implementing with the initial landing of the new migrator (unless UX comes decide otherwise before the new migrator lands). It can, of course, easily be disabled or tweaked later. Once the migrator lands, I'll provide a patch here to disable Top Sites migration in case we don't want to release this part.

Alternatively, the migrator can create a Top Sites folder (under the Bookmarks Menu or under From Safari, see above). The shortcoming would be that we're "promoting" a feature we don't have.

Reading List
------------
This is a little bit more complex. Despite the label, Reading list items are, in a way, similar to Unsorted Bookmarks, especially because it's the default location for new bookmarks (Ctrl+D + Enter == new item to read). However, the feature is pretty new in Safari, and it's not yet clear how people use it. Also note that items don't go away from the reading list once and item is considered "read". Instead, Safari has two views for its Reading List: one just for new items and one for all items.

Unsorted Bookmarks are probably the way to go for start-up-migration, but I'm not so sure about migration from the Places Organizer. Another question is whether or not to migrate read items.

With the initial landing of the new migrator, I'm going with migrating all reading list items as bookmarks, regardless of the migration type. As with Top Sites, I'll put a patch here to disable this part of the migrator, just in case.

CCing Limi for input.</Description></bugID>